# ------------------------------------------------------------
# icscateg.pl filter ics files
# m@wjst.de 26Dec07
# ------------------------------------------------------------
#!/usr/local/bin/perl

if ($ARGV[0] eq "") {
	print ("ICSCATEG input.ics output.ics categoryname\n");
	exit(1);
}

open(IN,$ARGV[0]);
open(OUT,">$ARGV[1]");
print OUT ("BEGIN:VCALENDAR\nVERSION:2.0\nPRODID:-//RSB//ICSCATEG//EN\n");

$b="BEGIN:VEVENT\n";
$e="END:VEVENT\n";
while(<IN>) {
	if (/\;/) {
		$s="\;";
	} else {
		$s="\:";
	}
	@ls = split(/$s/);
	$ls[1] =~ s/\n//i;
	if ( $ls[0] eq "BEGIN" ) {
		$SUMMARY="";$DTSTART="";$DTEND="";$DTSTAMP="";$LOCATION="";$DESCRIPTION="";$CATEGORIES="";$CLASS="";
	}
	if ( $ls[0] eq "SUMMARY" )	{$SUMMARY	="SUMMARY$s$ls[1]\n";}
	if ( $ls[0] eq "DTSTART")	{$DTSTART	="DTSTART$s$ls[1]\n";}
	if ( $ls[0] eq "DTEND" ) 	{$DTEND		="DTEND$s$ls[1]\n";}
	if ( $ls[0] eq "DTSTAMP" )	{$DTSTAMP	="DTSTAMP$s$ls[1]\n";}
	if ( $ls[0] eq "LOCATION")	{$LOCATION	="LOCATION$s$ls[1]\n";}
	if ( $ls[0] eq "DESCRIPTION")	{$DESCRIPTION	="DESCRIPTION$s$ls[1]\n";}
	if ( $ls[0] eq "CATEGORIES")	{$CATEGORIES	="CATEGORIES$s$ls[1]\n";}
	if ( $ls[0] eq "CLASS" ) 	{$CLASS		="CLASS$s$ls[1]\n";}
	if ( $ls[0] eq "END" ) {
		if ( $CATEGORIES =~ /.*($ARGV[2]).*/) {
			print OUT ("$b$SUMMARY$DTSTART$DTEND$DTSTAMP$LOCATION$DESCRIPTION$CATEGORIES$e");
		}
	}
}

print OUT ("END:VCALENDAR");

close IN;
close OUT;
exit(0);
